!--------------------------------------------------------------------------------------------------
!  DOXYGEN
!> @brief Brief of Module DGNSERV... 
!! @details Details of Module DGNSERV... 
!! @author Lucci 
!! @date 18-03-20 \n
!<
!> @details <b>Use Module:</b>   
!! @arg @c F77KINDS
!! @arg @c PARMETA 
!! @details <b>Driver:</b> 
!<
!--------------------------------------------------------------------------------------------------
    MODULE DGNSERV
!--------------------------------------------------------------------------------------------------
! MODULE DGNSERV
!
! USE MODULES: F77KINDS
!              PARMETA
!
! DRIVER     : 
!--------------------------------------------------------------------------------------------------
    USE F77KINDS
    USE PARMETA
!
    IMPLICIT NONE
!
    INTEGER(KIND=I4)    , PARAMETER :: IGM = 128
    INTEGER(KIND=I4)    , PARAMETER :: JGM =  51
!
    REAL   (KIND=R4)    , DIMENSION(IGM, JGM)                                                   ::&
    & GLON    , GLAT    , XMP0    , YMP0
!
    INTEGER(KIND=I4)    , DIMENSION(IGM, JGM)                                                   ::&
    & KMP0
!
    REAL   (KIND=R4)    , DIMENSION(0:IM0+1, 0:JM0+1, NM)                                       ::&
    & U2US    , U2VS    , V2US    , V2VS
!
    REAL   (KIND=R8)    , DIMENSION(IGM, JGM, LM)                                               ::&
    & TLLAVG  , THLLAVG , TLLAVG2 , ULLAVG  , ULLAVG2
!
    REAL   (KIND=R8)    , DIMENSION(IGM, JGM, LM)                                               ::&
    & UVAR_AVG
!
    REAL   (KIND=R8)    , DIMENSION(JGM, LM)                                                    ::&
    & TZN2_AVG
!
    END MODULE DGNSERV
